commit 9366c328518766d896155388726055624716c0af
Author: Wilco Dijkstra <wilco.dijkstra@arm.com>
Date:   Tue Dec 10 14:22:48 2024 +0000

    arm: Fix LDRD register overlap [PR117675]
    
    The register indexed variants of LDRD have complex register overlap constraints
    which makes them hard to use without using output_move_double (which can't be
    used for atomics as it doesn't guarantee to emit atomic LDRD/STRD when required).
    Add a new predicate and constraint for plain LDRD/STRD with base or base+imm.
    This blocks register indexing and fixes PR117675.
    
    gcc:
            PR target/117675
            * config/arm/arm.cc (arm_ldrd_legitimate_address): New function.
            * config/arm/arm-protos.h (arm_ldrd_legitimate_address): New prototype.
            * config/arm/constraints.md: Add new Uo constraint.
            * config/arm/predicates.md (arm_ldrd_memory_operand): Add new predicate.
            * config/arm/sync.md (arm_atomic_loaddi2_ldrd): Use
            arm_ldrd_memory_operand and Uo.
    
    gcc/testsuite:
            PR target/117675
            * gcc.target/arm/pr117675.c: Add new test.
    
    (cherry picked from commit 21fbfae2e55e1a153820acc6fbd922e66f67e65b)

diff --git a/gcc/config/arm/arm-protos.h b/gcc/config/arm/arm-protos.h
index 2cd560c9925..89e804225a8 100644
--- a/gcc/config/arm/arm-protos.h
+++ b/gcc/config/arm/arm-protos.h
@@ -202,6 +202,7 @@ extern rtx arm_load_tp (rtx);
 extern bool arm_coproc_builtin_available (enum unspecv);
 extern bool arm_coproc_ldc_stc_legitimate_address (rtx);
 extern rtx arm_stack_protect_tls_canary_mem (bool);
+extern bool arm_ldrd_legitimate_address (rtx);
 
 
 #if defined TREE_CODE
diff --git a/gcc/config/arm/arm.cc b/gcc/config/arm/arm.cc
index 912f2c31576..7b3b26a5951 100644
--- a/gcc/config/arm/arm.cc
+++ b/gcc/config/arm/arm.cc
@@ -34523,6 +34523,30 @@ arm_coproc_ldc_stc_legitimate_address (rtx op)
   return false;
 }
 
+/* Return true if OP is a valid memory operand for LDRD/STRD without any
+   register overlap restrictions.  Allow [base] and [base, imm] for now.  */
+bool
+arm_ldrd_legitimate_address (rtx op)
+{
+  if (!MEM_P (op))
+    return false;
+
+  op = XEXP (op, 0);
+  if (REG_P (op))
+    return true;
+
+  if (GET_CODE (op) != PLUS)
+    return false;
+  if (!REG_P (XEXP (op, 0)) || !CONST_INT_P (XEXP (op, 1)))
+    return false;
+
+  HOST_WIDE_INT val = INTVAL (XEXP (op, 1));
+
+  if (TARGET_ARM)
+    return IN_RANGE (val, -255, 255);
+  return IN_RANGE (val, -1020, 1020) && (val & 3) == 0;
+}
+
 /* Return the diagnostic message string if conversion from FROMTYPE to
    TOTYPE is not allowed, NULL otherwise.  */
 
diff --git a/gcc/testsuite/gcc.target/arm/pr117675.c b/gcc/testsuite/gcc.target/arm/pr117675.c
new file mode 100644
index 00000000000..586bc9db90a
--- /dev/null
+++ b/gcc/testsuite/gcc.target/arm/pr117675.c
@@ -0,0 +1,17 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -marm" } */
+/* { dg-require-effective-target arm_arch_v7ve_neon_ok } */
+/* { dg-add-options arm_arch_v7ve_neon } */
+/* { dg-final { check-function-bodies "**" "" "" } } */
+
+/*
+** f1:
+**	add	r0, r0, r1
+**	ldrd	r0, r1, \[r0\]
+**	bx	lr
+*/
+long long f1 (char *p, int i)
+{
+  return __atomic_load_n ((long long *)(p + i), __ATOMIC_RELAXED);
+}
+

